class FeldsController < ApplicationController

  helper_method             :list, :list_leichen 

  def edit_called_by_tree
    info  = felds(params[:idnr])
    unless info.empty? 
      redirect_to :action => "message", :controller => 'application' , :confirm => info
    else
      render :action    => 'edit'
    end
  end
  
  def edit
    params[:idnr] = params[:id]     unless params[:idnr]
    edit_called_by_tree     if params[:idnr].to_i > 0
  end

  # <b>list</b> listet alle Feld-Datenstze auf
  
  def list(error=false)
    @feld_pages = Paginator.new self, Feld.count, 20, @params[:page]
    options = [ "eigenschaft = ? AND datei != ? ", 0, @@gone]   if error      # Fehlerhafte Stze sind solche ohne Eigenschaft - aber keine "Leichen"
    @felds =  Feld.find :all, :conditions => options,     # options = nil klappt fein
              :order => 'datei, name',
              :limit  =>  @feld_pages.items_per_page,
              :offset =>  @feld_pages.current.offset
    render :action => 'index'
  end

  # <b>list_error</b> listet nur die fehlerhaften Stze auf  

  def list_error
    list(true)
  end
  
  # <b>list_leichen</b> listet nur die berzhligen Stze auf  

  def list_leichen
    @leftover         = Feld.find_all_by_datei(@@gone)
    params[:leichen]  = true
    render :action    => 'index'
  end  

  # <b>update</b> aktualisiert den Datensatz
  # Besonderheit: Felder werden nie angelegt oder gelscht - nur ber "datenbank.rb" aus der physikalischen Datenbank heraus

  def update      
    info          = felds(params[:id])
    unless info.empty?
      render :partial => "application/message", :locals => {:confirm => info}   
    else     
      do_save         # incl. render
    end
  end

  # <b>destroy</b> lscht das berzhlige Feld
  
  def destroy
    Feld.find(params[:id]).destroy
    redirect_to :action => 'list_leichen'
  end
  
  # <b>reset</b> fhrt das Reset aus fr Edit-Templates aus
  
  def reset
    felds(params[:id])
    render :partial => "edit", :locals => {:function => {'reset' => ''} }
  end
   
  # <b>droptext</b> ermittelt die Drop-Texte
  
  def droptext(id, index, dropped)
    modul = "Feld"
    case index
    when 0
      modul = "Eigenschaft"
      tt    = 'Um die Eigenschaft zu &auml;ndern, einfach dieses Icon auf die gew&uuml;nschte Eigenschaft ziehen.'
      del   = ''        #    Eigenschaft ist erforderlich - nderung ja, Lschen nein
    when 1
      tt    = "Soll ein f&uuml;hrendes Feld als Redundanz des vorliegenden Feldes bestimmt werden, einfach dieses Icon auf das betreffende Feld ziehen"    
      del   = 'L&ouml;scht das f&uuml;hrende Feld'   
    when 2
      tt    = "Soll ein Vorg&auml;nger bestimmt werden, einfach dieses Icon auf das betreffende Feld ziehen"    
      del   = 'L&ouml;scht den Vorg&auml;nger'   
    else
      tt    = "Soll ein Nachfolger bestimmt werden, einfach dieses Icon auf das betreffende Feld ziehen"    
      del   = 'L&ouml;scht den Nachfolger'   
    end
    begin
      me  = eval("#{modul}.find(dropped.to_i)")   if dropped.to_i > 0
    rescue
    end
    result  = me.nil? ? ['', '', 0] : [me.name, me.beschreibung, me.id]
    result  << tt
    result  << del
    result  << ( (@felds.redundant > 0) && (index > 1)   ?  'hide': '' )
    result
  end
  
  ######################################################################################################    
  
  private

  # <b>dropped</b> bearbeitet den Drag-Drop-Vorgang

  def dropped(view, dropped, idnr)
    index     = idnr[1].to_i
    case index
    when 0
      feldname  = 'eigenschaft'
      tooltip   = 'Um die Eigenschaft zu &auml;ndern, einfach dieses Icon auf die gew&uuml;nschte Eigenschaft ziehen.'
    when 1
      feldname  = 'redundant'
      tooltip   = 'Soll ein f&uuml;hrendes Feld als Redundanz des vorliegenden Feldes bestimmt werden, einfach dieses Icon auf das betreffende Feld ziehen.'
    when 2
      feldname  = 'vorgaenger'
      tooltip   = 'Soll ein Vorgnger bestimmt werden, einfach dieses Icon auf das betreffende Feld ziehen.'
    else
      feldname  = 'nachfolger'
      tooltip   = 'Soll ein Nachfolger bestimmt werden, einfach dieses Icon auf das betreffende Feld ziehen.'
    end

    if view == 'NaviSeite-2' && index != 0 && dropped.to_i > 0
      msg               = 'Es wurde die &Auml;nderung eines Feldes angefordert. Bitte in die Anzeige f&uuml;r Felder wechseln.' 
    elsif view != 'NaviSeite-2' && index == 0 && dropped.to_i > 0
      msg               = 'Es wurde die &Auml;nderung einer Eigenschaft angefordert. Bitte in die Anzeige f&uuml;r Eigenschaften wechseln.' 
    else
      info              = felds(idnr[0].to_i)
      if info.empty?
        if dropped.to_i > 0  
          @felds.check      = {feldname, dropped}
          ok                = @felds.valid?
        else
          dropped           = 0
          ok                = true
        end
        if ok
          @dropdrag[index]  = dropped 
        else
          msg               = @felds.errors.on(feldname) 
        end
      else
        msg = "Der Vorgang konnte f&uuml;r diese Eigenschaft aus folgendem Grund nicht ausgef&uuml;hrt werden:<br>" + info[2]
      end
    end
    flash[:notice]  = msg
    msg             = (@felds.errors.count > 0) || !msg.nil? ? "<div class=\"popup_error\">#{flash[:notice]}</div>" : ""
    return [@dropdrag, msg]
  end

  # <b>do_save</b> fhrt die Prfungen und Aktualisierungen fr update aus ("new" existiert fr Felder nicht)
  
  def do_save
    dropped             = [params[:drop_mem_0], params[:drop_mem_1], params[:drop_mem_2], params[:drop_mem_3]]    # Name der Hidden-Felde
    prv                 = [@felds.eigenschaft, @felds.redundant, @felds.vorgaenger, @felds.nachfolger]

    endstation          = params[:endstation].nil? ? false : true      # ist die Checkbox nicht angeklickt - so ist sie nil
    if endstation == true
      dropped[3]          = '-1'
    end            
    
    @felds.attributes   = params[:felds]
    @felds.check        = { 'eigenschaft'   => dropped[0],
                            'redundant'     => dropped[1],
                            'vorgaenger'    => dropped[2],
                            'nachfolger'    => dropped[3],
                            'beschreibung'  => @felds.beschreibung, # ggf. Unterlassungswert einfgen
                            'anzahl'        => @felds.anzahl}       # ggf. Unterlassungswert einfgen
                            
    if @felds.valid?        # setzt ber call_record auch die attribute von @check
      @felds.save_me(prv)
      @dropdrag           = [@felds.eigenschaft, @felds.redundant, @felds.vorgaenger, @felds.nachfolger]      # Aktualisierung der Instanzvariablen

      if prv[0] == 0        # Fehleranzeige im Baum korrigieren
        view_tree("noDB", "", "clear")
      end      
      
      # Rendering
      function            = {}      # Javascript-Funktionen fr Rendering
      function['reload']  = ''      # liest die gesamte Seite neu ein, um auch die Ajax-Werte "festzuschreiben"       

      render :partial => "edit", :locals => {:function => function}    

    else        # Fehler
      notice, msg           = "", []
      @felds.errors.each {|attr, msg| notice << "#{msg}<br>"}
      confirm               = ['edit', 'error', notice ]
      render :partial => "edit", :locals => {:confirm => confirm}  
    end
  end

  # <b>felds</b> ermittelt den Satz, bestimmt die Werte bei neu anzulegenden oder gibt Fehler aus
  # Besonderheit: Felder werden nie angelegt - nur ber "datenbank.rb" aus der physikalischen Datenbank heraus
 
  def felds(id, todo = '')
    info                  = []
    begin
      @felds              = Feld.find(id)   # id muss existieren
    rescue
      notice              = "Das angeforderte Feld mit der Satznummer \"#{id}\" konnte nicht gefunden werden. 
                            Dies k&ouml;nnte daran liegen, dass Sie auf einen &uuml;berholten Stand der Anzeige gebl&auml;ttert haben 
                            und l&auml;sst sich durch \"Neuladen\" des Browsers bereinigen.
                            Bitte w&auml;hlen Sie ein anderes Feld aus."
      if todo == '-1'
        notice  = ''
        feld(id.to_i-1, todo)
      end
      info                = ['edit', 'error', notice ]    unless notice.empty?
    end
  
    # Ergebnisse
    if @felds
      @dropdrag         = [@felds.eigenschaft, @felds.redundant, @felds.vorgaenger, @felds.nachfolger]
      @new              = false
    end
    info
    
  end

end
